project "Irrlicht"
    kind "StaticLib"

    includedirs { "include", "src", "src/jpeglib", "src/libpng", "src/zlib" }
    
    defines { "_IRR_STATIC_LIB_" }
    exceptionhandling "Off"
    rtti "Off"
    
    files { "src/CCgMaterialRenderer.cpp",
            "src/CD3D9CgMaterialRenderer.cpp",
            "src/CDefaultSceneNodeAnimatorFactory.cpp",
            "src/CDefaultSceneNodeFactory.cpp",
            "src/CGeometryCreator.cpp",
            "src/CMeshCache.cpp",
            "src/CMeshManipulator.cpp",
            "src/COpenGLCgMaterialRenderer.cpp",
            "src/CSceneManager.cpp",
            "src/C3DSMeshFileLoader.cpp",
            "src/CSMFMeshFileLoader.cpp",
            "src/CAnimatedMeshHalfLife.cpp",
            "src/CAnimatedMeshMD2.cpp",
            "src/CAnimatedMeshMD3.cpp",
            "src/CB3DMeshFileLoader.cpp",
            "src/CBSPMeshFileLoader.cpp",
            "src/CColladaFileLoader.cpp",
            "src/CCSMLoader.cpp",
            "src/CDMFLoader.cpp",
            "src/CIrrMeshFileLoader.cpp",
            "src/CLMTSMeshFileLoader.cpp",
            "src/CLWOMeshFileLoader.cpp",
            "src/CMD2MeshFileLoader.cpp",
            "src/CMD3MeshFileLoader.cpp",
            "src/CMS3DMeshFileLoader.cpp",
            "src/CMY3DMeshFileLoader.cpp",
            "src/COBJMeshFileLoader.cpp",
            "src/COCTLoader.cpp",
            "src/COgreMeshFileLoader.cpp",
            "src/CPLYMeshFileLoader.cpp",
            "src/CQ3LevelMesh.cpp",
            "src/CSkinnedMesh.cpp",
            "src/CSTLMeshFileLoader.cpp",
            "src/CXMeshFileLoader.cpp",
            "src/CAnimatedMeshSceneNode.cpp",
            "src/CBillboardSceneNode.cpp",
            "src/CBoneSceneNode.cpp",
            "src/CCameraSceneNode.cpp",
            "src/CCubeSceneNode.cpp",
            "src/CDummyTransformationSceneNode.cpp",
            "src/CEmptySceneNode.cpp",
            "src/CLightSceneNode.cpp",
            "src/CMeshSceneNode.cpp",
            "src/COctreeSceneNode.cpp",
            "src/CQuake3ShaderSceneNode.cpp",
            "src/CShadowVolumeSceneNode.cpp",
            "src/CSkyBoxSceneNode.cpp",
            "src/CSkyDomeSceneNode.cpp",
            "src/CSphereSceneNode.cpp",
            "src/CTerrainSceneNode.cpp",
            "src/CTextSceneNode.cpp",
            "src/CVolumeLightSceneNode.cpp",
            "src/CWaterSurfaceSceneNode.cpp",
            "src/CParticleAnimatedMeshSceneNodeEmitter.cpp",
            "src/CParticleAttractionAffector.cpp",
            "src/CParticleBoxEmitter.cpp",
            "src/CParticleCylinderEmitter.cpp",
            "src/CParticleFadeOutAffector.cpp",
            "src/CParticleGravityAffector.cpp",
            "src/CParticleMeshEmitter.cpp",
            "src/CParticlePointEmitter.cpp",
            "src/CParticleRingEmitter.cpp",
            "src/CParticleRotationAffector.cpp",
            "src/CParticleScaleAffector.cpp",
            "src/CParticleSphereEmitter.cpp",
            "src/CParticleSystemSceneNode.cpp",
            "src/CMetaTriangleSelector.cpp",
            "src/COctreeTriangleSelector.cpp",
            "src/CSceneCollisionManager.cpp",
            "src/CTerrainTriangleSelector.cpp",
            "src/CTriangleBBSelector.cpp",
            "src/CTriangleSelector.cpp",
            "src/CSceneLoaderIrr.cpp",
            "src/CSceneNodeAnimatorCameraFPS.cpp",
            "src/CSceneNodeAnimatorCameraMaya.cpp",
            "src/CSceneNodeAnimatorCollisionResponse.cpp",
            "src/CSceneNodeAnimatorDelete.cpp",
            "src/CSceneNodeAnimatorFlyCircle.cpp",
            "src/CSceneNodeAnimatorFlyStraight.cpp",
            "src/CSceneNodeAnimatorFollowSpline.cpp",
            "src/CSceneNodeAnimatorRotation.cpp",
            "src/CSceneNodeAnimatorTexture.cpp",
            "src/CColladaMeshWriter.cpp",
            "src/CIrrMeshWriter.cpp",
            "src/COBJMeshWriter.cpp",
            "src/CPLYMeshWriter.cpp",
            "src/CSTLMeshWriter.cpp",
            "src/CVideoModeList.cpp",
            "src/CSoftwareDriver.cpp",
            "src/CSoftwareTexture.cpp",
            "src/CTRFlat.cpp",
            "src/CTRFlatWire.cpp",
            "src/CTRGouraud.cpp",
            "src/CTRGouraudWire.cpp",
            "src/CTRTextureFlat.cpp",
            "src/CTRTextureFlatWire.cpp",
            "src/CTRTextureGouraud.cpp",
            "src/CTRTextureGouraudAdd.cpp",
            "src/CTRTextureGouraudNoZ.cpp",
            "src/CTRTextureGouraudWire.cpp",
            "src/CZBuffer.cpp",
            "src/COpenGLDriver.cpp",
            "src/COpenGLExtensionHandler.cpp",
            "src/COpenGLNormalMapRenderer.cpp",
            "src/COpenGLParallaxMapRenderer.cpp",
            "src/COpenGLShaderMaterialRenderer.cpp",
            "src/COpenGLSLMaterialRenderer.cpp",
            "src/COpenGLTexture.cpp",
            "src/CD3D8Driver.cpp",
            "src/CD3D8NormalMapRenderer.cpp",
            "src/CD3D8ParallaxMapRenderer.cpp",
            "src/CD3D8ShaderMaterialRenderer.cpp",
            "src/CD3D8Texture.cpp",
            "src/CColorConverter.cpp",
            "src/CFPSCounter.cpp",
            "src/CImage.cpp",
            "src/CNullDriver.cpp",
            "src/CImageWriterBMP.cpp",
            "src/CImageWriterJPG.cpp",
            "src/CImageWriterPCX.cpp",
            "src/CImageWriterPNG.cpp",
            "src/CImageWriterPPM.cpp",
            "src/CImageWriterPSD.cpp",
            "src/CImageWriterTGA.cpp",
            "src/CImageLoaderBMP.cpp",
            "src/CImageLoaderDDS.cpp",
            "src/CImageLoaderJPG.cpp",
            "src/CImageLoaderPCX.cpp",
            "src/CImageLoaderPNG.cpp",
            "src/CImageLoaderPPM.cpp",
            "src/CImageLoaderPSD.cpp",
            "src/CImageLoaderRGB.cpp",
            "src/CImageLoaderTGA.cpp",
            "src/CImageLoaderWAL.cpp",
            "src/CD3D9Driver.cpp",
            "src/CD3D9HLSLMaterialRenderer.cpp",
            "src/CD3D9NormalMapRenderer.cpp",
            "src/CD3D9ParallaxMapRenderer.cpp",
            "src/CD3D9ShaderMaterialRenderer.cpp",
            "src/CD3D9Texture.cpp",
            "src/CBurningShader_Raster_Reference.cpp",
            "src/CDepthBuffer.cpp",
            "src/CSoftwareDriver2.cpp",
            "src/CSoftwareTexture2.cpp",
            "src/CTRGouraud2.cpp",
            "src/CTRGouraudAlpha2.cpp",
            "src/CTRGouraudAlphaNoZ2.cpp",
            "src/CTRNormalMap.cpp",
            "src/CTRStencilShadow.cpp",
            "src/CTRTextureBlend.cpp",
            "src/CTRTextureDetailMap2.cpp",
            "src/CTRTextureGouraud2.cpp",
            "src/CTRTextureGouraudAdd2.cpp",
            "src/CTRTextureGouraudAddNoZ2.cpp",
            "src/CTRTextureGouraudAlpha.cpp",
            "src/CTRTextureGouraudAlphaNoZ.cpp",
            "src/CTRTextureGouraudNoZ2.cpp",
            "src/CTRTextureGouraudVertexAlpha2.cpp",
            "src/CTRTextureLightMap2_Add.cpp",
            "src/CTRTextureLightMap2_M1.cpp",
            "src/CTRTextureLightMap2_M2.cpp",
            "src/CTRTextureLightMap2_M4.cpp",
            "src/CTRTextureLightMapGouraud2_M4.cpp",
            "src/CTRTextureWire2.cpp",
            "src/IBurningShader.cpp",
            "src/CLogger.cpp",
            "src/COSOperator.cpp",
            "src/Irrlicht.cpp",
            "src/os.cpp",
            "src/lzma/LzmaDec.c",
            "src/zlib/adler32.c",
            "src/zlib/compress.c",
            "src/zlib/crc32.c",
            "src/zlib/deflate.c",
            "src/zlib/inffast.c",
            "src/zlib/inflate.c",
            "src/zlib/inftrees.c",
            "src/zlib/trees.c",
            "src/zlib/uncompr.c",
            "src/zlib/zutil.c",
            "src/jpeglib/jaricom.c",
            "src/jpeglib/jcapimin.c",
            "src/jpeglib/jcapistd.c",
            "src/jpeglib/jcarith.c",
            "src/jpeglib/jccoefct.c",
            "src/jpeglib/jccolor.c",
            "src/jpeglib/jcdctmgr.c",
            "src/jpeglib/jchuff.c",
            "src/jpeglib/jcinit.c",
            "src/jpeglib/jcmainct.c",
            "src/jpeglib/jcmarker.c",
            "src/jpeglib/jcmaster.c",
            "src/jpeglib/jcomapi.c",
            "src/jpeglib/jcparam.c",
            "src/jpeglib/jcprepct.c",
            "src/jpeglib/jcsample.c",
            "src/jpeglib/jctrans.c",
            "src/jpeglib/jdapimin.c",
            "src/jpeglib/jdapistd.c",
            "src/jpeglib/jdarith.c",
            "src/jpeglib/jdatadst.c",
            "src/jpeglib/jdatasrc.c",
            "src/jpeglib/jdcoefct.c",
            "src/jpeglib/jdcolor.c",
            "src/jpeglib/jddctmgr.c",
            "src/jpeglib/jdhuff.c",
            "src/jpeglib/jdinput.c",
            "src/jpeglib/jdmainct.c",
            "src/jpeglib/jdmarker.c",
            "src/jpeglib/jdmaster.c",
            "src/jpeglib/jdmerge.c",
            "src/jpeglib/jdpostct.c",
            "src/jpeglib/jdsample.c",
            "src/jpeglib/jdtrans.c",
            "src/jpeglib/jerror.c",
            "src/jpeglib/jfdctflt.c",
            "src/jpeglib/jfdctfst.c",
            "src/jpeglib/jfdctint.c",
            "src/jpeglib/jidctflt.c",
            "src/jpeglib/jidctfst.c",
            "src/jpeglib/jidctint.c",
            "src/jpeglib/jmemmgr.c",
            "src/jpeglib/jmemnobs.c",
            "src/jpeglib/jquant1.c",
            "src/jpeglib/jquant2.c",
            "src/jpeglib/jutils.c",
            "src/libpng/png.c",
            "src/libpng/pngerror.c",
            "src/libpng/pngget.c",
            "src/libpng/pngmem.c",
            "src/libpng/pngpread.c",
            "src/libpng/pngread.c",
            "src/libpng/pngrio.c",
            "src/libpng/pngrtran.c",
            "src/libpng/pngrutil.c",
            "src/libpng/pngset.c",
            "src/libpng/pngtrans.c",
            "src/libpng/pngwio.c",
            "src/libpng/pngwrite.c",
            "src/libpng/pngwtran.c",
            "src/libpng/pngwutil.c",
            "src/aesGladman/aescrypt.cpp",
            "src/aesGladman/aeskey.cpp",
            "src/aesGladman/aestab.cpp",
            "src/aesGladman/fileenc.cpp",
            "src/aesGladman/hmac.cpp",
            "src/aesGladman/prng.cpp",
            "src/aesGladman/pwd2key.cpp",
            "src/aesGladman/sha1.cpp",
            "src/aesGladman/sha2.cpp",
            "src/bzip2/blocksort.c",
            "src/bzip2/bzcompress.c",
            "src/bzip2/bzlib.c",
            "src/bzip2/crctable.c",
            "src/bzip2/decompress.c",
            "src/bzip2/huffman.c",
            "src/bzip2/randtable.c",
            "src/CIrrDeviceConsole.cpp",
            "src/CIrrDeviceFB.cpp",
            "src/CIrrDeviceLinux.cpp",
            "src/CIrrDeviceSDL.cpp",
            "src/CIrrDeviceStub.cpp",
            "src/CIrrDeviceWin32.cpp",
            "src/CIrrDeviceWinCE.cpp",
            "src/CAttributes.cpp",
            "src/CFileList.cpp",
            "src/CFileSystem.cpp",
            "src/CLimitReadFile.cpp",
            "src/CMemoryFile.cpp",
            "src/CMountPointReader.cpp",
            "src/CNPKReader.cpp",
            "src/CPakReader.cpp",
            "src/CReadFile.cpp",
            "src/CTarReader.cpp",
            "src/CWADReader.cpp",
            "src/CWriteFile.cpp",
            "src/CXMLReader.cpp",
            "src/CXMLWriter.cpp",
            "src/CZipReader.cpp",
            "src/irrXML.cpp",
            "src/CDefaultGUIElementFactory.cpp",
            "src/CGUIButton.cpp",
            "src/CGUICheckbox.cpp",
            "src/CGUIColorSelectDialog.cpp",
            "src/CGUIComboBox.cpp",
            "src/CGUIContextMenu.cpp",
            "src/CGUIEditBox.cpp",
            "src/CGUIEnvironment.cpp",
            "src/CGUIFileOpenDialog.cpp",
            "src/CGUIFont.cpp",
            "src/CGUIImage.cpp",
            "src/CGUIImageList.cpp",
            "src/CGUIInOutFader.cpp",
            "src/CGUIListBox.cpp",
            "src/CGUIMenu.cpp",
            "src/CGUIMeshViewer.cpp",
            "src/CGUIMessageBox.cpp",
            "src/CGUIModalScreen.cpp",
            "src/CGUIScrollBar.cpp",
            "src/CGUISkin.cpp",
            "src/CGUISpinBox.cpp",
            "src/CGUISpriteBank.cpp",
            "src/CGUIStaticText.cpp",
            "src/CGUITabControl.cpp",
            "src/CGUITable.cpp",
            "src/CGUIToolBar.cpp",
            "src/CGUITreeView.cpp",
            "src/CGUIWindow.cpp" }

    configuration { "vs*" }
            includedirs { "$(DXSDK_DIR)include" }
        libdirs { "$(DXSDK_DIR)Lib/x86" }

    configuration { "windows" }
        links { "imm32" }
